<!--
  Created by CPL.
  User: Carlos
  Date: 21/06/2024
  Time: 9:25
  To change this template use File | Settings | File Templates | JSP Bootstrap 5.
-->
<!doctype html>
<html xmlns:th="http://www.thymeleaf.org" lang="ES-es">
<head>
	<!-- Required meta tags -->
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	
	<!-- Bootstrap CSS -->
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet"
	      integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
	<!-- Bootstrap icons -->
	<link href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.2/font/bootstrap-icons.min.css" rel="stylesheet">
	<!-- Estilos personalizados -->
	<link href="" type="text/css" rel="stylesheet">
	
	<title>Lista de clientes</title>
</head>
<body>
	<div class="container">
		<form action="/flash" method="POST">
			<button type="submit">Prueba flash</button>
		</form>
		
		<!--/* Mensajes para el usuario. EL tipo de mensaje y el texto se reciben desde el controlador en los atributos
		       "clase" y "mensaje". La clase es de la de Bootstrap (primary, danger, ...) para el tipo alert */-->
		<div class="alert alert-dismissible fade show" id="mensajeAlerta" role="alert" th:if="${mensaje}" th:classappend="'alert-' + ${clase}">
			<span th:text="${mensaje}"></span>
			<button  type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
		</div>
		
		
		<!--/*  Fila con tabla de datos */-->
		<div class="row">
			<div class="col">
				<!--/* Tabla con los clientes. */-->
				<table class="table table-striped">
					<tr>
						<th>Id</th>
						<th>Nombre</th>
						<th>Dni</th>
						<th>Edad</th>
						<th></th>  <!--/* Esta columna es para poner los iconos de editar y borrar */-->
					</tr>
					<th:block>
						<!--/* Si no hay clientes, se visualiza un mensaje. */-->
						<tr th:if="${clientes.size() == 0}" colspan="5" class="table-warning">
							<td>No se han encontrado clientes.</td>
						</tr>
						<!--/* Si hay clientes, generamos cada una de las filas desde la lista de clientes que recibimos
							desde el controlador mediante Thymeleaf
							ejemplo:
							<tr th:each="smokeTest : ${smokeTests}">
								<td th:text="${smokeTest.name}">A Smoke Test'</td>
							</tr>
							
							En la última columna colocamos los dos iconos: editar y borrar
						*/-->
						<tr th:unless="${clientes.size() == 0}" th:each="cli : ${clientes}" >
							<td th:id="${cli.getId()}" th:text="${cli.getId()}"></td>
							<td th:text="${cli.getNombre()}"></td>
							<td th:text="${cli.getDni()}"></td>
							<td th:text="${cli.getEdad()}"></td>
							<td>
								<!--/* Botón para editar cliente */-->
								<!--
								<button class="border-0 bg-transparent" data-bs-target="#formOpcionesModal"
								        data-bs-toggle="modal"
								        th:attr="data-bs-valor=${opc.valor()},
										                    data-bs-etiqueta=${opc.etiqueta()},
															data-bs-comentarios=${opc.comentarios()},
															data-bs-opcionId=${opc.id()},
															data-bs-listaID=${lista.key},
															data-bs-accion='editarOpcion'">
									<i aria-describedby="btnEditaOpcion" class="bi bi-pencil-fill"
									   data-bs-placement="top"
									   data-bs-toggle="tooltip"
									   id="btnEditaOpcion"
									   title="Editar los datos de esta opción"></i>
								</button>
								-->
								<!--/* Botón para borrar cliente.
								        Los atributos "data-" se utilizan para personalizar el modal de confirmación
								        con los datos del cliente.
								        
								        Se asignan al modal mediante JS con la función que se ejecuta al dispararse el
								        evento "show-bs-modal" qye es el que dispara Bootstrap al visualizar el modal
								        (consultar https://getbootstrap.com/docs/5.0/components/modal/#events)
								*/-->
								<button class="border-0 bg-transparent"
								        data-bs-target="#confirmaBorradoModal"
								        data-bs-toggle="modal"
								        th:attr="data-id=${cli.getId()},
										            data-tituloPre='cliente',
													data-tituloPost=${cli.getNombre()},
													data-mensaje='el cliente &lt<strong>' + ${cli.getNombre()} +
														'</strong>&gt',
													data-url='/clientes/borrar/'">
									<i aria-describedby="btnEliminaCliente" class="bi bi-trash3-fill"
									   data-bs-placement="top"
									   data-bs-toggle="tooltip"
									   id="btnEliminaCliente"
									   title="Eliminar este cliente de la bbdd"></i>
								</button>
							</td>
						</tr>
					</th:block>
				</table>
			</div>
		</div>
	</div>
	
	<!--  Modal para confirmar el borrado  -->
	<div class="modal fade" id="confirmaBorradoModal" tabindex="-1" aria-labelledby="confirmaBorradoModal"
	     aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title">Confirmar borrado</h5>
					<button type="button" class="btn-close"  data-bs-dismiss="modal" aria-label="Close"></button>
				</div>
				<div class="modal-body">
				
				</div>
				<div class="modal-footer">
					<button type="submit" id="btnEliminar" class="btn btn-danger"
					        data-url = "" onclick="borrar(this)">Eliminar</button>
				</div>
			</div>
		</div>
	</div>
	
	<!-- Optional JavaScript -->
	<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.6/dist/umd/popper.min.js"
	        integrity="sha384-oBqDVmMz9ATKxIep9tiCxS/Z9fNfEXiDAYTujMAeBAsjFuCZSmKbSSUnQlmh/jp3"
	        crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.min.js"
	        integrity="sha384-cuYeSxntonz0PPNlHhBs68uyIAVpIIOZZ5JqeqvYYIcEL727kskC66kF92t6Xl2V"
	        crossorigin="anonymous"></script>
	
	<script th:inline="javascript">
		/*[- */
		/*  El botón que llama al modal de borrado -el icono de borrado- debe pasar como dataset los siguientes valores:
		* id            -> id del elemento a borrar
		* tituloPre     -> texto del título del modal después de "Eliminar"
		* tituloPost    -> texto del título del modal después de <
		* mensaje       -> cadena de texto del mensaje
		* url           -> url a llamar al pulsar el botón de confirmación de borrado. La llamada será tipo ajax con
		*                  un comando DELETE
	    */
		/* -]*/
		(function () {
			document.getElementById("confirmaBorradoModal").addEventListener("show.bs.modal", (event) => {
				// botón que ha disparado el modal
				const btn = event.relatedTarget;
				// Obtenemos los datos del atributo 'data-*'
				const datos = btn.dataset;
				// Actualizamos los campos del modal con los valores y fijamos el atributo action del formulario
				let titulo = event.target.querySelector('.modal-header>h5');
				titulo.textContent = 'Eliminar ' + datos['titulopre'] + '<' + datos['titulopost'] + '>';
				event.target.querySelector('.modal-body').innerHTML = '<p>Esta acción no se puede deshacer.<br>' +
						'¿Está seguro que desea eliminar permanentemente ' + datos['mensaje'] + '</p>';
				document.getElementById("btnEliminar").dataset.url = datos['url'];
				document.getElementById("btnEliminar").dataset.id = datos['id'];
			})
		})();
		/*[- */
		/*  Al hacer clic en dicho botón, se activa la función que envía una petición AJAX con el verbo DELETE a la
			url del servidor definida en el atributo "data-url" del icono de borrar en cada fila.
		*/
		/* -]*/
		async function borrar(btn) {
			try {
				/*[- */ //Preparamos la llamada y esperamos la respuesta   /* -]*/
				const response = await fetch(btn.dataset.url, {
					method: 'DELETE',
					headers: {'Content-Type': 'application/json'},
					body: JSON.stringify({id: btn.dataset.id})
				});
				const resp = await response.json();
				
				// Cerramos el modal ...
				const modal = document.getElementById("confirmaBorradoModal");
				bootstrap.Modal.getInstance(modal).hide();
				
				// ... Ponemos el mensaje de resultado (alert) ...
				// ... identificamos el alert ...
				const msgAlert = document.querySelector('#mensajeAlerta')
				// ... añadimos la clase que hemos recibido del servidor ...
				msgAlert.classList.add('alert-'.concat(resp.clase != null ? resp.clase : 'info'));
				// ... añadimos el mensaje ...
				const mensaje = document.createElement('span');
				mensaje.innerHTML = resp.mensaje != null ? resp.mensaje : 'respuesta sin mensaje';
				msgAlert.insertBefore(mensaje, msgAlert.firstChild);
				// ... lo visualizamos ...
				msgAlert.style.visibility = 'visible'
				// ... y lo cerramos a los tres segundos
				setTimeout(function () {
					msgAlert.style.visibility = 'hidden'
					msgAlert.removeChild(msgAlert.firstChild);
				}, 2000)
			} catch (error) {
				alert("Se ha producido un error al solicitar el borrado.\n" + error);
			}
		}
		
		function ponAlert(clase, mensaje) {
		
		}
	</script>
</body>
</html>